/*
 * Config File
 * Contains constants including
 * field size
 * cellwidth/height
 * goal width (double goalWidth (mm))
 * hum_cells
 * robot ids
 * robot team?
 * action weights  (all positive)
 */

#ifndef __CONFIG_H_
#define __CONFIG_H_

#include <string>
#include "Vector.h"

using namespace std;

class Config {

	public:
		Config();
		Config( char* filename );
		void loadConfigFile( char* filename );

		Vector numCells;
		Vector fieldDimensions;
		
		double goalWidth;

		double friendlySigma;

		int numRobots;
		int numOurRobots;
		int numActions;
		int direction;

		string visHost, commHost;
		int visPort, commPort;

		string names[8];
		char* actionNames[6];
		int ids[8];

		string ballName;

		int unixPort;

		double timeWeight;
		
		double robotClearDist;
		double robotVelocity;
		double throughBallDistance;
		double robotShootClearDist;
		double robotShootClearDistRange;
		

		double shootWeight,	clearWeight, blockWeight, annoyWeight, getopenWeight;

		int verbose;

	private:
		
		
	
};

#endif
