#ifndef __POTENTIAL_H_
#define __POTENTIAL_H_

#include "Vector.h"

class PotentialMap
{
 public:
  PotentialMap() {};
  PotentialMap(Vector fieldDimensions, Vector numCells);
  PotentialMap(const PotentialMap &rhs);
  PotentialMap& operator=(const PotentialMap &rhs);
  ~PotentialMap();
  void print();
  void setCell(int x, int y, double d);
  void setCellReal(double x, double y, double d);
  double getCell(int x, int y);
  Vector getMin();
  Vector getMax();  
  PotentialMap operator+(const PotentialMap &rhs);
  Vector cellToCoord(int x, int y);
  Vector coordToCell(double x, double y);
  void clear();

 private:
  double field_width, field_height, cellWidth, cellHeight;
  int num_cells_x, num_cells_y;
  double **map;
  //double map[1000][500];


};

#endif
