#include "Vector.h"

Vector::Vector(double cx, double cy)
{
	xcoord = cx;    ycoord = cy;
}

Vector Vector::operator -(Vector RHS)
{
	return Vector(xcoord - RHS.x(), ycoord - RHS.y());
}

Vector Vector::operator +(Vector RHS)
{
	return Vector(xcoord + RHS.x(), ycoord + RHS.y());
}

Vector Vector::operator *(double value)
{
	return Vector(xcoord*value, ycoord*value);
}

void Vector::operator=(Vector RHS)
{
	xcoord = RHS.x();
	ycoord = RHS.y();
}

double Vector::magnitude(void)
{
	return sqrt(xcoord*xcoord + ycoord*ycoord);
}

double Vector::angle(void) {
	return atan2(ycoord, xcoord);
}

Vector Vector::normalize(void)
{
	double mag = magnitude();

	if(mag == 0)
		return Vector(0, 0);
	else
		return Vector(xcoord/mag, ycoord/mag);
}

double Vector::dot(Vector RHS)
{
	return xcoord*RHS.x() + ycoord*RHS.y();
}

double Vector::cross(Vector RHS)
{
	return (xcoord*RHS.y()) - (ycoord*RHS.x());
}

//absolute value of difference in angles.
double Vector::abs_angle_diff(Vector RHS)
{
  double diff;
  diff = fabs( angle() - RHS.angle() );

  //  if( RHS.angle() >= angle() )
  //    diff *= -1;

  //  if (diff > M_PI )
  //    diff -= 2*M_PI;

  if (diff > M_PI )
    diff = 2*M_PI - diff;
  return diff;
  
}

void Vector::print(char* s) {
	printf("%s: [%f,%f]\n", s, xcoord, ycoord); 
}

void Vector::print() {
	print("Vector");
}
