#ifndef __VISION_CLIENT_H_
#define __VISION_CLIENT_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netdb.h>
#include <pthread.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <iostream>
#include <stdlib.h>
#include <pthread.h>
#include "Ball.h"
#include "Brain.h"
#include "Robot.h"
#include "Vector.h"
#include "Config.h"

class VisionClient
{
  
 private:

  string hostname;
  int newFlag;
  int clientSocket( int port );
  int connectVision(string host, int port );
  void fillRobot(Robot* robot, string buf);
  void fillBall(Ball* ball, string buf);
  string advance(string *buf, char sentinel);

  pthread_t recvThread;



 public:
  VisionClient();
  //VisionClient(string host, int port);
  int init(string host, int port);
  ~VisionClient();
  int getData(Robot* robots, Ball* ball);
  void getMessage(char* buf);

  string buffer;
  int msgReady;
  int visPort, visSocket;
  int threadAlive;
};

#endif
